//	yaneCriticalSection.h :
//		programmed by yaneurao	'00/03/02

#ifndef __yaneCriticalSection_h__
#define __yaneCriticalSection_h__


class ICriticalSection {
public:
	virtual void	Enter()=0;
	virtual void	Leave()=0;
	virtual bool	IsLockedByThisThread() const =0;
	virtual ~ICriticalSection(){}
};

class CCriticalSection2 : public ICriticalSection {
/**
@XbhԂ̔r𐧌䂵܂B
@XbhEnter֐ĂяoƁALeave֐Ăяo܂ł̊Ԃ́A
@NeBJZNVƂȂ܂B
@NeBJZNVAɂQȏ̃Xbhs邱Ƃ͏o܂B
@XbhȂ΁AdEnter邱Ƃo܂B
@iڂ́A}`Xbh֌W̕QƂ邱Ɓj

  class CMutex ɔrāAɍȂ̂łB

  ӁF
  @CCriticalSection2̎̂́AO[oXR[vɒuA
  @staticȃoϐɂ邩ĂB
*/
public:
	virtual void	Enter();	///	CriticalSectionɓ
	virtual void	Leave();	///	CriticalSectiono

	virtual bool	IsLockedByThisThread() const;
	/**
		̃XbhɂLockĂtrue
	*/

	CCriticalSection2();
	virtual ~CCriticalSection2();
protected:
	CRITICAL_SECTION	m_csCriticalSection;
	DWORD				m_dwLockedThread;	//	LockĂThreadId(0:Lock)
	int					m_nLockCount;		//	LockĂ
			//	(XbhȂΕLockł̂)
};

class CCriticalLock {
/**
	NeBJZNV̎gp⏕NX
		CCriticalSection2EnterɓƂɗO
		̊֐甲Ă܂̂ŁALeaveȂč邱ƂB
	ŁA
		{
			CCriticalLock guard(GetCriticalSection());
			//	ɂ̏
		}
	Ƃ悤Ɏg΁AOƂĂÃNX
	fXgN^ŁACCriticalSection2::LeaveĂяo邱Ƃ
	ۏ؂܂B

	܂ALeave/EnterŁAILeave/Enter邱ƂłB

		PD
		{
			CCriticalLock guard(GetCriticalSection());
			guard.Leave();	//	CriticalSection甲
			//	̂܂܃XR[vAEgꍇACCriticalSection2::Leave
			//	ĂяoȂ
		}

		QD
		{
			CCriticalLock guard(GetCriticalSection());
			guard.Enter();	//	CriticalSectionɓdɓ
			//	̂܂܃XR[vAEgꍇACCriticalSection2::Leave
			//	QxĂяo
		}

		@Enter/LeavéACCriticalLock̃CX^X𐶐
			XbhȊÕXbhĂяoƂ͑z肵ĂȂB


			//	synchronizedNX(yaneLockObject.h)QƂ̂
*/
public:
	CCriticalLock(ICriticalSection* cs);

	///	ICriticalSection甲
	void	Leave();

	///	ICriticalSectionɓ
	void	Enter();

	~CCriticalLock();

protected:
	ICriticalSection* m_cs;
	int m_nLockCount;	//	LockĂ
	//	CCriticalLock̃fXgN^ł́ALock(Enter)ꂽ񐔂Unlock(Leave)邱Ƃۏ؂
};

//	Ȃ_~[̃bN@\񋟂
class SingleThread
{
protected:
	struct Lock {
		Lock(const SingleThread&) {};
	};
};

//	IuWFNgPʂ̃bN@\񋟂
class MultiThread
{
protected:
	struct Lock {
		Lock(const MultiThread& o)
			: lock_object( &(const_cast<MultiThread&>(o).cs) ) {};
	private:
		CCriticalLock lock_object;
	};
private:
	friend struct Lock;
	CCriticalSection2 cs;
};

#endif
